=== debian/changelog ===
dynare (7~beta1-1) experimental; urgency=medium

  * New upstream version 7~beta1
  * d/copyright: reflect upstream changes
  * Remove libgsl-dev and libmatio-dev from (Build-)Depends
  * Add octave-datatypes to Recommends
  * Add python3-sphinxcontrib.bibtex to Build-Depends
  * Drop “Priority: optional”, which is now the default
  * Bump Standards-Version to 4.7.3

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 03 Mar 2026 17:05:42 +0100
